"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var fastDeepEqual = require("fast-deep-equal");
var mobx_1 = require("mobx");
var validation_1 = require("./validation");
var utils_1 = require("./utils");
var Field = /** @class */ (function () {
    function Field(defaultValue, _a) {
        var _this = this;
        var validate = _a.validate, _b = _a.debounce, debounce = _b === void 0 ? false : _b, _c = _a.disabled, disabled = _c === void 0 ? false : _c, _d = _a.validationContext, validationContext = _d === void 0 ? validation_1.defaultValidationContext : _d, formater = _a.formater, parser = _a.parser, label = _a.label;
        this._value = null;
        this._interacted = false;
        this.disabled = false;
        this._isValidFn = [];
        this.markAsTouched = function () {
            if (!_this._interacted) {
                _this._interacted = true;
            }
        };
        this.markAsUntouched = function () {
            if (_this._interacted) {
                _this._interacted = false;
            }
        };
        this.setValue = function (val, _a) {
            var _b = _a === void 0 ? {} : _a, _c = _b.interract, interract = _c === void 0 ? true : _c, _d = _b.isInitValue, isInitValue = _d === void 0 ? false : _d;
            if (interract && !_this._interacted) {
                _this._interacted = true;
            }
            _this._value = val;
            if (isInitValue) {
                _this.initValue = val;
            }
        };
        this.onInputChange = function (evt, value) {
            if (evt && typeof value === "undefined") {
                value = evt.target.value;
            }
            var parsedValue = _this.parser ? _this.parser(value) : value;
            if (parsedValue !== _this._value) {
                _this.setValue(parsedValue, { interract: false });
            }
        };
        this.validate = function () { return __awaiter(_this, void 0, void 0, function () {
            var validationContext, lastRes, i, isValidFn, res;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        validationContext = this.validationContext(this._value, this.label);
                        i = 0;
                        _a.label = 1;
                    case 1:
                        if (!(i < this._isValidFn.length)) return [3 /*break*/, 5];
                        isValidFn = this._isValidFn[i];
                        res = isValidFn(validationContext);
                        if (!utils_1.isPromise(res)) return [3 /*break*/, 3];
                        return [4 /*yield*/, res];
                    case 2:
                        res = _a.sent();
                        _a.label = 3;
                    case 3:
                        if (!res || !(typeof res === "object")) {
                            throw new Error("Invalid validator result");
                        }
                        lastRes = res;
                        if (!res.valid || res.stop) {
                            return [3 /*break*/, 5];
                        }
                        _a.label = 4;
                    case 4:
                        i++;
                        return [3 /*break*/, 1];
                    case 5:
                        if (lastRes) {
                            this.setValidation(lastRes);
                        }
                        return [2 /*return*/];
                }
            });
        }); };
        this.disabled = disabled;
        this.formater = formater;
        this.parser = parser;
        this.validationContext = validationContext;
        this.defaultValue = defaultValue;
        this.initValue = defaultValue;
        this.setValue(defaultValue, { interract: false });
        if (label) {
            this.label = label;
        }
        if (validate) {
            if (validate instanceof Array) {
                this._isValidFn = validate;
            }
            else {
                this._isValidFn = [validate];
            }
        }
        if (this._isValidFn.length) {
            this._validation = { valid: false };
            mobx_1.autorun(this.validate, { delay: debounce ? 300 : 0 });
        }
        else {
            this._validation = { valid: true };
        }
    }
    Field.prototype.reset = function (_a) {
        var _b = _a === void 0 ? {} : _a, _c = _b.untouched, untouched = _c === void 0 ? false : _c, _d = _b.defaultValue, defaultValue = _d === void 0 ? false : _d;
        if (defaultValue) {
            this.initValue = this.defaultValue;
        }
        this._value = this.initValue;
        if (untouched) {
            this.markAsUntouched();
        }
    };
    Field.prototype.setDisabled = function (value) {
        this.disabled = value;
    };
    Object.defineProperty(Field.prototype, "value", {
        get: function () {
            return this._value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Field.prototype, "inputValue", {
        get: function () {
            return this.formater ? this.formater(this._value) : this._value;
        },
        enumerable: true,
        configurable: true
    });
    Field.prototype.setValidation = function (validation) {
        this._validation = validation;
    };
    Object.defineProperty(Field.prototype, "errorMessage", {
        get: function () {
            if (!this._interacted || !this._validation) {
                return "";
            }
            return this._validation.message || "";
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Field.prototype, "isValid", {
        get: function () {
            return this._validation.valid;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Field.prototype, "validation", {
        get: function () {
            return this._validation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Field.prototype, "interacted", {
        get: function () {
            return this._interacted;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Field.prototype, "pristine", {
        get: function () {
            return fastDeepEqual(this.initValue, this.value);
        },
        enumerable: true,
        configurable: true
    });
    Field.prototype.onChange = function (fn) {
        var _this = this;
        this._dispose = mobx_1.reaction(function () { return _this.value; }, function (value) {
            fn(value);
        });
    };
    Field.prototype.destroy = function () {
        if (this._dispose) {
            this._dispose();
        }
    };
    __decorate([
        mobx_1.observable,
        __metadata("design:type", Object)
    ], Field.prototype, "_value", void 0);
    __decorate([
        mobx_1.observable,
        __metadata("design:type", Object)
    ], Field.prototype, "_interacted", void 0);
    __decorate([
        mobx_1.observable,
        __metadata("design:type", Object)
    ], Field.prototype, "_validation", void 0);
    __decorate([
        mobx_1.observable,
        __metadata("design:type", Object)
    ], Field.prototype, "disabled", void 0);
    __decorate([
        mobx_1.observable,
        __metadata("design:type", Object)
    ], Field.prototype, "initValue", void 0);
    __decorate([
        mobx_1.action("FIELD_RESET"),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object]),
        __metadata("design:returntype", void 0)
    ], Field.prototype, "reset", null);
    __decorate([
        mobx_1.action("FIELD_SET_DISABLED"),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Boolean]),
        __metadata("design:returntype", void 0)
    ], Field.prototype, "setDisabled", null);
    __decorate([
        mobx_1.action("FIELD_MARK_AS_TOUCH"),
        __metadata("design:type", Object)
    ], Field.prototype, "markAsTouched", void 0);
    __decorate([
        mobx_1.action("FIELD_MARK_AS_UNTOUCHED"),
        __metadata("design:type", Object)
    ], Field.prototype, "markAsUntouched", void 0);
    __decorate([
        mobx_1.computed,
        __metadata("design:type", Object),
        __metadata("design:paramtypes", [])
    ], Field.prototype, "value", null);
    __decorate([
        mobx_1.action("SET_FIELD_VALUE"),
        __metadata("design:type", Object)
    ], Field.prototype, "setValue", void 0);
    __decorate([
        mobx_1.computed,
        __metadata("design:type", Object),
        __metadata("design:paramtypes", [])
    ], Field.prototype, "inputValue", null);
    __decorate([
        mobx_1.action("SET_FIELD_VALIDATION"),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object]),
        __metadata("design:returntype", void 0)
    ], Field.prototype, "setValidation", null);
    __decorate([
        mobx_1.computed,
        __metadata("design:type", Object),
        __metadata("design:paramtypes", [])
    ], Field.prototype, "errorMessage", null);
    __decorate([
        mobx_1.computed,
        __metadata("design:type", Object),
        __metadata("design:paramtypes", [])
    ], Field.prototype, "isValid", null);
    __decorate([
        mobx_1.computed,
        __metadata("design:type", Object),
        __metadata("design:paramtypes", [])
    ], Field.prototype, "pristine", null);
    return Field;
}());
exports.default = Field;
//# sourceMappingURL=Field.js.map