"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var fastDeepEqual = require("fast-deep-equal");
var mobx_1 = require("mobx");
var FieldsArray = /** @class */ (function () {
    function FieldsArray(defaultValue, _a) {
        var validate = (_a === void 0 ? {} : _a).validate;
        this.validate = validate;
        this.fields = mobx_1.observable.array(defaultValue, { deep: false });
        this.defaultValue = this.value;
        this.initValue = this.value;
    }
    FieldsArray.prototype.reset = function (_a) {
        var _b = _a === void 0 ? {} : _a, _c = _b.untouched, untouched = _c === void 0 ? false : _c, _d = _b.defaultValue, defaultValue = _d === void 0 ? false : _d;
        if (defaultValue) {
            this.initValue = this.defaultValue;
        }
        this.setValue(this.initValue);
        // this.setValue(this.initValue as FieldsArrayData<TField>[]);
        if (untouched) {
            this.markAsUntouched();
        }
    };
    FieldsArray.prototype.markAsTouched = function () {
        this.fields.forEach(function (field) { return field.markAsTouched(); });
    };
    FieldsArray.prototype.markAsUntouched = function () {
        this.fields.forEach(function (field) { return field.markAsUntouched(); });
    };
    FieldsArray.prototype.setValue = function (data, _a) {
        var _this = this;
        var _b = _a === void 0 ? {} : _a, _c = _b.interract, interract = _c === void 0 ? false : _c, _d = _b.isInitValue, isInitValue = _d === void 0 ? false : _d;
        if (!data) {
            return;
        }
        // Set fields length to data length
        this.fields.splice(data.length, this.fields.length - data.length);
        // Set fields values to data values
        data.forEach(function (dataField, i) {
            // FIXME: if fields[i] is undefined it will throw an error, we need to have a builder function
            return _this.fields[i].setValue(dataField, {
                interract: interract,
                isInitValue: isInitValue,
            });
        });
        if (isInitValue) {
            this.initValue = data;
        }
    };
    FieldsArray.prototype.get = function (index) {
        return this.fields[index];
    };
    Object.defineProperty(FieldsArray.prototype, "validation", {
        get: function () {
            if (this.validate) {
                var validation = this.validate(this.value);
                if (!validation.valid) {
                    return validation;
                }
            }
            var invalidField = this.fields.find(function (field) { return !field.isValid; });
            if (invalidField) {
                return invalidField.validation;
            }
            return {
                valid: true,
            };
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FieldsArray.prototype, "isValid", {
        get: function () {
            return this.validation.valid;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FieldsArray.prototype, "value", {
        get: function () {
            return this.fields.map(function (field) { return field.value; });
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FieldsArray.prototype, "interacted", {
        get: function () {
            return this.fields.some(function (field) { return field.interacted; });
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FieldsArray.prototype, "pristine", {
        get: function () {
            // FIXME how to detect pristine state
            return fastDeepEqual(this.initValue, this.value);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FieldsArray.prototype, "errorMessage", {
        get: function () {
            return this.validation.message || "";
        },
        enumerable: true,
        configurable: true
    });
    __decorate([
        mobx_1.observable,
        __metadata("design:type", Array)
    ], FieldsArray.prototype, "fields", void 0);
    __decorate([
        mobx_1.observable,
        __metadata("design:type", Array)
    ], FieldsArray.prototype, "initValue", void 0);
    __decorate([
        mobx_1.action("FIELD_ARRAY_RESET"),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object]),
        __metadata("design:returntype", void 0)
    ], FieldsArray.prototype, "reset", null);
    __decorate([
        mobx_1.action("FIELD_ARRAY_MAT"),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", []),
        __metadata("design:returntype", void 0)
    ], FieldsArray.prototype, "markAsTouched", null);
    __decorate([
        mobx_1.action("FIELD_ARRAY_MAUT"),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", []),
        __metadata("design:returntype", void 0)
    ], FieldsArray.prototype, "markAsUntouched", null);
    __decorate([
        mobx_1.action("FIELD_ARRAY_SETVALUE"),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Array, Object]),
        __metadata("design:returntype", void 0)
    ], FieldsArray.prototype, "setValue", null);
    __decorate([
        mobx_1.computed,
        __metadata("design:type", Object),
        __metadata("design:paramtypes", [])
    ], FieldsArray.prototype, "validation", null);
    __decorate([
        mobx_1.computed,
        __metadata("design:type", Object),
        __metadata("design:paramtypes", [])
    ], FieldsArray.prototype, "isValid", null);
    __decorate([
        mobx_1.computed,
        __metadata("design:type", Array),
        __metadata("design:paramtypes", [])
    ], FieldsArray.prototype, "value", null);
    __decorate([
        mobx_1.computed,
        __metadata("design:type", Boolean),
        __metadata("design:paramtypes", [])
    ], FieldsArray.prototype, "interacted", null);
    __decorate([
        mobx_1.computed,
        __metadata("design:type", Object),
        __metadata("design:paramtypes", [])
    ], FieldsArray.prototype, "pristine", null);
    __decorate([
        mobx_1.computed,
        __metadata("design:type", Object),
        __metadata("design:paramtypes", [])
    ], FieldsArray.prototype, "errorMessage", null);
    return FieldsArray;
}());
exports.default = FieldsArray;
//# sourceMappingURL=FieldsArray.js.map