import Field, { FieldOpts, FieldType } from "./Field";
import FieldsObject, { FieldsObjectOpts } from "./FieldObject";
import FieldsArray, { FieldsArrayData, FieldsArrayOpts } from "./FieldsArray";
export declare const getInputFieldProps: <TValue, TInputValue>(field: Field<TValue, TInputValue>) => {
    value: TValue | TInputValue | null;
    onChange: (evt: any, value: TInputValue) => void;
    error: import("./validation").ErrorMessage;
    onBlur: () => void;
    disabled: boolean;
};
export declare const getSwitchProps: <TValue, TInputValue>(field: Field<TValue, TInputValue>) => {
    checked: TValue | TInputValue | null;
    onChange: (evt: any, value: TInputValue) => void;
    onBlur: () => void;
};
declare class FieldBuilder {
    field<TValue, TInputValue = TValue>(initValue: TValue | null, obj?: FieldOpts<TValue | null, TInputValue>): Field<TValue, TInputValue>;
    obj<TFields>(fields: TFields, obj?: FieldsObjectOpts<TFields>): FieldsObject<TFields>;
    array<TField extends FieldType<FieldsArrayData<TField>>, TData = FieldsArrayData<TField>>(initValue: TField[], obj?: FieldsArrayOpts<TData>): FieldsArray<TField, TData>;
}
export declare const fb: FieldBuilder;
export * from "./validation";
export * from "./validators";
export { FieldsObject, Field, FieldsArray };
