export interface ValidationObj {
    valid: boolean;
    message?: ErrorMessage;
    stop?: boolean;
}
export interface ValidationContext<TValue> {
    value?: TValue;
    label?: string;
}
export declare type ValidationContextBuilder<TValue> = (value?: TValue, label?: string) => ValidationContext<TValue>;
export declare type ValidationFunction<TValue> = (context: ValidationContext<TValue>) => ValidationObj | Promise<ValidationObj>;
export declare function defaultValidationContext<TValue>(value?: TValue, label?: string): ValidationContext<TValue>;
export declare const next: () => ValidationObj;
export declare const error: (code: string, params: {}) => ValidationObj;
export declare const stop: () => ValidationObj;
export interface I18nMessage {
    code: string;
    params: {};
}
export declare type ErrorMessage = string | I18nMessage;
